#include <iostream>  // For cout  and NULL
#include "eg141_NumberList.h"
using namespace std;

void eg141_NumberList::appendNode(double num)
{
	ListNode *newNode; //point to a new node
	ListNode *nodePtr; //to move through the list

	//allocate a new node and store num there
	newNode = new ListNode;
	newNode->value = num;
	newNode->next = NULL;

	//if no node in the list, make it first node
	if (!head)   //!NULL gives true
	{	head = newNode;}
	else
	{	//insert newNode at end
		nodePtr = head;
		//find the last node, traverse the list
		while (nodePtr->next)
			nodePtr = nodePtr->next;
		//insert newNode as last node
		nodePtr->next = newNode;
	}
}


void eg141_NumberList::displayList() const
{
	ListNode *nodePtr; //to move through the list

	//position node at the head
	nodePtr = head;
	//traverse the list
	while (nodePtr)
	{
		cout << nodePtr->value << endl;
		nodePtr = nodePtr->next;
	}
}

void eg141_NumberList::insertNode(double num)
{
	ListNode *newNode; //new node to be added
	ListNode *nodePtr; //to traverse
	ListNode *previousNode = NULL; //the previous node

	//allocate a new node and store num there
	newNode = new ListNode;
	newNode->value = num;

	//if there is no node on list, make the newnode the first
	if (!head)   //!NULL gives true
	{	head = newNode;
		newNode->next = NULL;
	}
	else //insert new node
	{
		nodePtr = head; //position at head
		previousNode = NULL; 

		//skip(traverse) all nodes whose value is less than num
		while (nodePtr != NULL && nodePtr->value < num)
		{
			previousNode = nodePtr;
			nodePtr = nodePtr->next;
		}
	

		//if the new node is to be the 1st, insert it before all other nodes (in other words num < nodePtr->value)
		if (previousNode == NULL)
		{
			head = newNode;
			newNode->next = nodePtr;
		}
		else	//not the first node? good insert the normal way
		{
			previousNode->next = newNode;
			newNode->next = nodePtr;
		}
	}
}


void eg141_NumberList::deleteNode(double num)
{
	ListNode *nodePtr; //to traverse
	ListNode *previousNode; //the previous node

	if (!head)	//empty list? do nothing
		return;

	//if the first node is the one
	if (head->value == num)
	{
		nodePtr = head->next;
		delete head;
		head = nodePtr;
	}
	else
	{
		nodePtr = head; //position at head

		//skip(traverse) all nodes whose value is not equal to num
		while (nodePtr != NULL && nodePtr->value != num)
		{
			previousNode = nodePtr;
			nodePtr = nodePtr->next;
		}

		//if nodePtr is not at the end, remove
		if (nodePtr)
		{
			previousNode->next = nodePtr->next;
			delete nodePtr;
		}
		//if at the end, means not found, do nothing
	}
}

eg141_NumberList::~eg141_NumberList()
{
	ListNode *nodePtr;
	ListNode *nextNode;

	nodePtr = head;

	//while not the end
	while (nodePtr != NULL)
	{
		nextNode = nodePtr->next;
		//delete the current node
		delete nodePtr;
		//position to next node
		nodePtr = nextNode;
	}
}